#ifndef STATUS_H
#define STATUS_H

#define STAT_OK                                 0       // OK
#define STAT_NOT_IMPLEMENTED_YET                1       // REQUESTED BEHAVIOUR NOT IMPLEMENTED YET
#define STAT_NOT_ENOUGHT_MEMORY                 2       // NOT ENOUGHT MEMORY TO COMPLETE REQUESTED OPERATION, TRY TO INCREASE GIVEN MEMORY BUFFER SIZE
#define STAT_DATA_CORRUPTED                     3       // GIVEN DATA ARE NOT IN EXPECTED FORMAT
#define STAT_DATA_INCORRECT_LENGTH              4       // LENGTH OF GIVEN DATA IS INCORRECT
#define STAT_FILE_OPEN_FAIL                     5       // FAIL TO OPEN TARGET FILE
#define STAT_NOT_ENOUGHT_DATA_TYPE              6       // GIVEN DATA VARIABLE IS UNABLE TO CONTAIN RETURN VALUE
#define STAT_USERDATA_BAD                       7       // DATA OBTAINED FROM USER INPUT ARE INVALID
#define STAT_KEY_LENGTH_BAD                     8       // KEY LENGTH DIFFERS FROM EXPECTED
#define STAT_CONFIG_DATA_READ_FAIL              9       // FAIL TO READ DATA FROM CONFIG FILE
#define STAT_INVALID_ARGUMETS                   10      // INVALID FUNCTION ARGUMENTS
#define STAT_CONFIG_INCORRECT                   11      // CONFIGURATION IS NOT CORRECT
#define STAT_FILE_WRITE_FAIL                    12      // FILE COULD NOT BE SAVED
#define STAT_CONFIG_SCRIPT_INCOMPLETE           13      // CONFIGURATION FILE IS INCOMPLETE
#define STAT_PROJECT_ERROR                      14      // ERROR IN PROJECT CLASSES
#define STAT_INTENTIONAL_EXIT                   15      // EXITING EACIRC INTENTIONALLY
#define STAT_FILE_READ_FAIL                     16      // READ FROM FILE UNSUCCESSFUL
#define STAT_EXTERNAL_SYSTEM_FAILED             17      // SOME EXTERNAL SYSTEM (E.G. MAPPING NET DRIVE) FAILED
#define STAT_CIRCUIT_INCONSISTENT               18      // CIRCUIT INCONSISTENT - UNKNOWN FUNCTIONS, UNSUPPORTED CONNECTOR MASK, ETC.
#define STAT_CIRCUIT_BACKEND_ERROR              19      // PROBLEM WITH CIRCUIT BACKEND

const char* statusToString(int error);

#endif
