#! /bin/bash

VERSION=1.0
CONFIG_NAME_PREFIX="config-"
CONFIG_NAME_SUFFIX=".xml"
# output dir must end with path separator
OUTPUT_DIR="configs/"

CONFIG0=﻿"<?xml version=\"1.0\" encoding=\"UTF-8\" ?>
<EACIRC>
<INFO>
    <DATE>2013-04-24</DATE>
    <VERSION>5.0</VERSION>
    <NOTES>file distinguisher - "
CONFIG1="</NOTES>
</INFO>

<MAIN>
    <PROJECT>400</PROJECT>
    <EVALUATOR>25</EVALUATOR>
    <RECOMMENCE_COMPUTATION>0</RECOMMENCE_COMPUTATION>
    <LOAD_INITIAL_POPULATION>0</LOAD_INITIAL_POPULATION>
    <NUM_GENERATIONS>30000</NUM_GENERATIONS>
    <SAVE_STATE_FREQ>1000</SAVE_STATE_FREQ>
</MAIN>

<RANDOM>
    <USE_FIXED_SEED>0</USE_FIXED_SEED>
    <SEED>145091104</SEED>
    <BIAS_RNDGEN_FACTOR>95</BIAS_RNDGEN_FACTOR>
    <USE_NET_SHARE>1</USE_NET_SHARE>
    <QRNG_PATH>../../qrng/;C:/RNG/;D:/RandomData/;K:/RandomData/</QRNG_PATH>
    <QRNG_MAX_INDEX>49</QRNG_MAX_INDEX>
</RANDOM>

<CUDA>
    <ENABLED>0</ENABLED>
    <SOMETHING>something</SOMETHING>
</CUDA>

<GA>
    <EVOLUTION_OFF>0</EVOLUTION_OFF>
    <PROB_MUTATION>0.05</PROB_MUTATION>
    <PROB_CROSSING>0.5</PROB_CROSSING>
    <POPULATION_SIZE>20</POPULATION_SIZE>
</GA>

<CIRCUIT>
    <NUM_LAYERS>5</NUM_LAYERS>
    <SIZE_LAYER>8</SIZE_LAYER>
    <SIZE_INPUT_LAYER>16</SIZE_INPUT_LAYER>
    <SIZE_OUTPUT_LAYER>2</SIZE_OUTPUT_LAYER>
    <NUM_CONNECTORS>4</NUM_CONNECTORS>
    <USE_MEMORY>0</USE_MEMORY>
    <MEMORY_SIZE>2</MEMORY_SIZE>
    <ALLOW_PRUNNING>1</ALLOW_PRUNNING>
    <ALLOWED_FUNCTIONS>
        <FNC_NOP>1</FNC_NOP>
        <FNC_OR>1</FNC_OR>
        <FNC_AND>1</FNC_AND>
        <FNC_CONST>1</FNC_CONST>
        <FNC_XOR>1</FNC_XOR>
        <FNC_NOR>1</FNC_NOR>
        <FNC_NAND>1</FNC_NAND>
        <FNC_ROTL>1</FNC_ROTL>
        <FNC_ROTR>1</FNC_ROTR>
        <FNC_BITSELECTOR>1</FNC_BITSELECTOR>
        <FNC_SUM>1</FNC_SUM>
        <FNC_SUBS>1</FNC_SUBS>
        <FNC_ADD>1</FNC_ADD>
        <FNC_MULT>1</FNC_MULT>
        <FNC_DIV>1</FNC_DIV>
        <FNC_READX>0</FNC_READX>
    </ALLOWED_FUNCTIONS>
</CIRCUIT>

<TEST_VECTORS>
    <INPUT_LENGTH>16</INPUT_LENGTH>
    <OUTPUT_LENGTH>2</OUTPUT_LENGTH>
    <SET_SIZE>1000</SET_SIZE>
    <SET_CHANGE_FREQ>100</SET_CHANGE_FREQ>
    <SET_CHANGE_PROGRESSIVE>0</SET_CHANGE_PROGRESSIVE>
    <SAVE_TEST_VECTORS>0</SAVE_TEST_VECTORS>
    <EVALUATE_BEFORE_TEST_VECTOR_CHANGE>0</EVALUATE_BEFORE_TEST_VECTOR_CHANGE>
    <EVALUATE_EVERY_STEP>0</EVALUATE_EVERY_STEP>
</TEST_VECTORS>

<ESTREAM>
    <USAGE_TYPE>101</USAGE_TYPE>
    <CIPHER_INIT_FREQ>1</CIPHER_INIT_FREQ>
    <ALGORITHM_1>13</ALGORITHM_1>
    <ALGORITHM_2>99</ALGORITHM_2>
    <BALLANCED_TEST_VECTORS>1</BALLANCED_TEST_VECTORS>
    <LIMIT_NUM_OF_ROUNDS>1</LIMIT_NUM_OF_ROUNDS>
    <ROUNDS_ALG_1>3</ROUNDS_ALG_1>
    <ROUNDS_ALG_2>0</ROUNDS_ALG_2>
    <PLAINTEXT_TYPE>0</PLAINTEXT_TYPE>
    <KEY_TYPE>2</KEY_TYPE>
    <IV_TYPE>0</IV_TYPE>
    <GENERATE_STREAM>0</GENERATE_STREAM>
    <STREAM_SIZE>5242880</STREAM_SIZE>
</ESTREAM>

<SHA3>
    <USAGE_TYPE>201</USAGE_TYPE>
    <PLAINTEXT_TYPE>210</PLAINTEXT_TYPE>
    <USE_FIXED_SEED>0</USE_FIXED_SEED>
    <SEED>145091104</SEED>
    <ALGORITHM_1>1</ALGORITHM_1>
    <ALGORITHM_2>2</ALGORITHM_2>
    <HASHLENGTH_ALG_1>256</HASHLENGTH_ALG_1>
    <HASHLENGTH_ALG_2>256</HASHLENGTH_ALG_2>
    <BALLANCED_TEST_VECTORS>1</BALLANCED_TEST_VECTORS>
    <LIMIT_NUM_OF_ROUNDS>0</LIMIT_NUM_OF_ROUNDS>
    <ROUNDS_ALG_1>3</ROUNDS_ALG_1>
    <ROUNDS_ALG_2>0</ROUNDS_ALG_2>
    <GENERATE_STREAM>1</GENERATE_STREAM>
    <STREAM_SIZE>5242880</STREAM_SIZE>
</SHA3>

<TEA>
</TEA>

<FILES>
    <USAGE_TYPE>401</USAGE_TYPE>
    <FILENAME_1>"
CONFIG2="</FILENAME_1>
    <FILENAME_2>"
CONFIG3="</FILENAME_2>
    <BALLANCED_TEST_VECTORS>1</BALLANCED_TEST_VECTORS>
    <USE_FIXED_INITIAL_OFFSET>1</USE_FIXED_INITIAL_OFFSET>
    <INITIAL_OFFSET_1>0</INITIAL_OFFSET_1>
    <INITIAL_OFFSET_2>0</INITIAL_OFFSET_2>
</FILES>

</EACIRC>"

if [ $# -le 1 ]
then
	echo "Config file generator for file distinguisher, version "$VERSION
	echo "usage: "$0" <file> <file> [<file> ...]"
	echo
	echo " - generates config file for each file pair"
	echo " - congig files are named "$CONFIG_NAME_PREFIX"<id>"$CONFIG_NAME_SUFFIX
	echo " - generate config files are saved in "$OUTPUT_DIR
	exit -1
fi

if [ ! -d $OUTPUT_DIR ]
then
	mkdir -p $OUTPUT_DIR
fi
ID=0
FILE1NUM=0
for FILE1 in "$@"
do
	FILE1NUM=$(($FILE1NUM+1))
	FILE2NUM=0
	for FILE2 in "$@"
	do
		FILE2NUM=$(($FILE2NUM+1))
		if [ $FILE1NUM -ge $FILE2NUM ]
		then continue
		fi
		ID=$(($ID+1))
		CONFIG_NAME=$CONFIG_NAME_PREFIX$ID$CONFIG_NAME_SUFFIX
		echo $CONFIG0$FILE1" vs. "$FILE2$CONFIG1$FILE1$CONFIG2$FILE2$CONFIG3 >$OUTPUT_DIR$CONFIG_NAME
	done
done
